<?php
namespace Teknisa\CTB\Modules\Saldos\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Teknisa\CTB\Modules\Saldos\Factories\Ctb22100RazaoGerencialFactory;

class Ctb22100RazaoGerencialService {

    protected $entityManager;
    protected $environment;
    protected $newCode;
    protected $factory;

    public function __construct(EntityManager $entityManager, Environment $environment, NewCode $newCode, Ctb22100RazaoGerencialFactory $factory) {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
        $this->newCode       = $newCode;
        $this->factory       = $factory;
    }

    public function geraRazaoGerencial($row) {
        try{
            $datainic   = $row['DTLANCCONT']["start"];
            $datafin    = $row['DTLANCCONT']["end"];
            $cdcontini  = $row['CDCONTCTBLINI'];
            $cdcontfin  = $row['CDCONTCTBLFIN'];

            $cdempresa  = isset($row['CDEMPRESA'])  ? implode('_', $row['CDEMPRESA'])  :'T';
            $cdregional = isset($row['CDREGIONAL']) ? implode('_', $row['CDREGIONAL']) :'T';
            $cdfilial   = isset($row['CDFILIAL'])   ? implode('_', $row['CDFILIAL'])   :'T';
            $cdcentcust = isset($row['CDCENTCUST']) ? implode('_', $row['CDCENTCUST']) :'T';

            $nrorg = $this->environment->getNrOrgTrab();
            $nrctbtemp = $this->newCode->getCodeByTableName('CTBTEMP', $nrorg, 1, 6);
            
            $this->factory->execProcGeraRazaoGerTemp(
               $cdempresa, $datainic, $datafin, $nrctbtemp, $cdregional, $cdfilial, $cdcentcust, $cdcontini, $cdcontfin
            );
        } catch (\Exception $e) {
            throw $e;
        }

        return $nrctbtemp;
    }


}